unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

Const
     maxn = 4;

type
    Data = Real;
    Matrix = Array[1..maxn, 1..maxn] of Data;
    Vector = Array[1..maxn] of Data;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Button1: TButton;
    lblX1: TLabel;
    lblX2: TLabel;
    lblX3: TLabel;
    lblX4: TLabel;
    Button2: TButton;
    Label6: TLabel;
    Edit1: TEdit;
    Button3: TButton;
    Edit2: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    Edit3: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
    Procedure WriteX(x: Vector);
    Function Gauss(n: Integer; a: Matrix; b: Vector; var x:Vector): Boolean;
    Function Seidel(n: Integer; a: Matrix; b: Vector; var x: Vector; e: Data) :Boolean;
    Function Iterat(n: Integer; a: Matrix; b: Vector; var x: Vector; e : Data; max_it : Integer) : boolean;
  public
    { Public declarations }
    a: Matrix ;
    b: Vector
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{      }

procedure TForm1.FormCreate(Sender: TObject);
begin
  a[1,1]:=-0.009; a[1,2]:=-4.998; a[1,3]:=-4.911; a[1,4]:=-4.483;
  a[2,1]:=-2.695; a[2,2]:=4.177; a[2,3]:=-0.683; a[2,4]:=-1.693;
  a[3,1]:=5.989; a[3,2]:=1.173; a[3,3]:=8.140; a[3,4]:=3.279;
  a[4,1]:=1.417; a[4,2]:=3.988; a[4,3]:=6.177; a[4,4]:=-3.831;
  b[1]:=7.611; b[2]:=8.652; b[3]:=3.413; b[4]:=2.613;
{  a[1,1]:=4.1; a[1,2]:=0.1; a[1,3]:=0.2; a[1,4]:=0.2;
  a[2,1]:=0.3; a[2,2]:=5.3; a[2,3]:=0.9; a[2,4]:=-0.1;
  a[3,1]:=0.2; a[3,2]:=0.3; a[3,3]:=3.2; a[3,4]:=0.2;
  a[4,1]:=0.1; a[4,2]:=0.1; a[4,3]:=0.2; a[4,4]:=-9.1;
  b[1]:=21.14; b[2]:=-17.82; b[3]:=9.02; b[4]:=17.08;}
end;

{    }

Procedure TForm1.WriteX(x: Vector);
Var
   i: Integer;
Begin
  lblX1.Caption := 'x1 = '+FloatToStrF(x[1],ffgeneral,7,2);
  lblX2.Caption := 'x2 = '+FloatToStrF(x[2],ffgeneral,7,2);
  lblX3.Caption := 'x3 = '+FloatToStrF(x[3],ffgeneral,7,2);
  lblX4.Caption := 'x4 = '+FloatToStrF(x[4],ffgeneral,7,2);
End;

{ ,    }

Function TForm1.Gauss(n: Integer; a: Matrix; b: Vector; var x:Vector): Boolean;
Var
   i, j, k, l: Integer;
   q, m, t: Data;
Begin

     For k := 1 to n - 1 do begin

         {   l     k- }
         l := 0;
         m := 0;
         For i := k to n do
             If Abs(a[i, k]) > m then begin
                m := Abs(a[i, k]);
                l := i;
             end;

         {      k  n   k-  ,
                      }
         If l = 0 then begin
            Gauss := false;
            Exit;
         end;

         {   l-   k- }
         If l <> k then begin
            For j := 1 to n do begin
                t := a[k, j];
                a[k, j] := a[l, j];
                a[l, j] := t;
            end;
            t := b[k];
            b[k] := b[l];
            b[l] := t;
         end;

         {   }
         For i := k + 1 to n do begin
             q := a[i, k] / a[k, k];
             For j := 1 to n do
                 If j = k then
                    a[i, j] := 0
                 else
                      a[i, j] := a[i, j] - q * a[k, j];
                 b[i] := b[i] - q * b[k];
             end;

     end;

     {   }
     x[n] := b[n] / a[n, n];
     For i := n - 1 downto 1 do begin
         t := 0;
         For j := 1 to n-i do
             t := t + a[i, i + j] * x[i + j];
         x[i] := (1 / a[i, i]) * (b[i] - t);
     end;

     Gauss := true;
End;

{ ,    }

Function TForm1.Seidel(n: Integer; a: Matrix; b: Vector; var x: Vector; e: Data) :Boolean;
Var
   i, j: Integer;
   s1, s2, s, v, m: Data;
Begin

     {   }
     For i := 1 to n do begin

         s := 0;
         For j := 1 to n do
             If j <> i then
                s := s + Abs(a[i, j]);

         If s >= Abs(a[i, i]) then begin
            Seidel := false;
            Exit;
         end;

     end;

     Repeat

         m := 0;
         For i := 1 to n do begin

             {   }
             s1 := 0;
             s2 := 0;
             For j := 1 to i - 1 do
                 s1 := s1 + a[i, j] * x[j];
             For j := i to n do
                 s2 := s2 + a[i, j] * x[j];

             {      }
             v := x[i];
             x[i] := x[i] - (1 / a[i, i]) * (s1 + s2 - b[i]);

             If Abs(v - x[i]) > m then
                m := Abs(v - x[i]);

         end;

     Until m < e;

     Seidel := true;
End;

Function TForm1.Iterat(n: Integer; a: Matrix; b: Vector; var x: Vector; e : Data; max_it : Integer) : boolean;
Var
  i, j, k:integer;
  s : real;
  X0 : Vector;
  q: Boolean;
begin
  result := false;
  for i:=1 to n do X0[i]:=0;
  for i:=1 to n do x[i]:=0;
  j:=0; q:=False; 
  repeat
    for i:=1 to n do
    begin
      s:=0;
      for k:=1 to n do if i<>k then s:=s+a[k,i]*x0[k];
      x[i]:=(b[i]-s)/a[i,i];
    end;
    for i:=1 to n do
    begin
      if abs(x[i]-x0[i])>e then q:=False else q:=True; x0[i]:=x[i];
    end;
    inc(j);
  until (j=max_it) or q;
if q<>False then result := true;
end;

{  }

procedure TForm1.Button1Click(Sender: TObject);
Var
   x: Vector;
begin
If Gauss(4, a, b, x) then WriteX(x)
else
   ShowMessage('      ');
end;

procedure TForm1.Button2Click(Sender: TObject);
Var
   i: Integer;
   x: Vector;
   e: Data;
begin
e := StrToFloat(Edit1.Text);
For i := 1 to 4 do
    x[i] := 0;
If Seidel(4, a, b, x, e) then WriteX(x)
else
   ShowMessage('      ');
end;

procedure TForm1.Button3Click(Sender: TObject);
Var
   max_it: Integer;
   x: Vector;
   e: Data;
begin
e := StrToFloat(Edit2.Text);
max_it := StrToInt(Edit3.Text);
If Iterat(4, a, b, x, e, max_it) then WriteX(x)
else
   ShowMessage('       ');
end;

end.
